
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// ---- Put a SOCK in it ------ Put a SOCK in it ------ Put a SOCK in it ----
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
//	
//		XXXXXX                     XXX       XX              
//		 XX  XX                     XX        X              
//		 XX  XX    XXXX    XXXXX    XX  XX   X       XXXXXXX 
//		 XXXXX    XX  XX  XX   XX   XX XX            XX      
//		 XX XX    XX  XX  XX        XXX              XXXXXXX 
//		 XX  XX   XX  XX  XX   XX   XX XX                 XX 
//		XXX  XX    XXXX    XXXXX   XXX  XX           XXXXXXX 
//		                                                     
//		
//		 XXXXXX                    XXX     
//		XX    X                     XX     
//		XX         XXXX    XXXXX    XX  XX 
//		 XXXXX    XX  XX  XX   XX   XX XX  
//		     XX   XX  XX  XX        XXX    
//		X    XX   XX  XX  XX   XX   XX XX  
//		XXXXXX     XXXX    XXXXX   XXX  XX 
//	                                   
//	
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// ---- Put a SOCK in it ------ Put a SOCK in it ------ Put a SOCK in it ----
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
//
//
// This is a client-side utility to let clients select a player and enable
// or disable the ignorePlayer() function on him.  Of course, you COULD add
// all sorts of client-side stuff to this framework.
//
//						Rock Diamond
//
//
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// ------ INSTRUCTIONS -- INSTRUCTIONS -- INSTRUCTIONS -- INSTRUCTIONS ------
// ------ INSTRUCTIONS -- INSTRUCTIONS -- INSTRUCTIONS -- INSTRUCTIONS ------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
//
// 1. Place this file in your ./Starsiege/scripts folder.
//
// 2. Using Notepad, open the following file:  ./Starsiege/scripts/autoexec.cs
//
// 3. At the bottom/end of the file, add the following line:
//
//		exec("scripts\\RocksSock.cs");
//
// 4. Make sure you've included the double-quotes, the double-backslash, and
//    the semicolon.
//
// 5. Close and save the file.  If you have other copies of the autoexec.cs
//    file located in other places (you shouldn't) then you may have problems
//    getting this to work.  That's because there is only supposed to be ONE
//    instance of the autoexec.cs file, and it is supposed to be located in
//    the ./Starsiege/scripts folder.
//
// 6. Here are the default in-game controls and key-bindings. You might want
//    to print them out and keep them as a reference.  Note that these bindings
//    do NOT clash with the bindings of the Rock's Server Admin Package.
//    Therefore, if you use that package too, you can still perform these
//    client-only functions in whichever server you're in.
//
//
//		Alt-right	Select Player forward
//	
//		Alt-left	Select Player backward
//	
//		Alt-t		Select the targeted Player
//
//		Alt-l		List all Players in the server
//	
//		Alt-s		Show the selected Player
//	
//		Alt-m		Mute the selected Player
//	
//		Alt-u		Unmute the selected Player
//	
//		Alt-[		Mute all Players
//	
//		Alt-]		Unmute all Players
//
//
//
//						Rock Diamond
//
//
//
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// These are your keybindings.  You can change them if you want, but don't
// change the codes in the RocksClientRemote() calls.
//


// Select forward
//
bind(keyboard0, make, alt,         "right", TO, "RocksClientRemote(300);");


// Select backward
//
bind(keyboard0, make, alt,         "left",  TO, "RocksClientRemote(301);");


// Select targeted player
//
bind(keyboard0, make, alt,         "t",     TO, "RocksClientRemote(302);");


// List all players
//
bind(keyboard0, make, alt,         "l",     TO, "RocksClientRemote(303);");


// Show selected player
//
bind(keyboard0, make, alt,         "s",     TO, "RocksClientRemote(304);");


// Mute selected player
//
bind(keyboard0, make, alt,         "m",     TO, "RocksClientRemote(305);");


// Unmute selected player
//
bind(keyboard0, make, alt,         "u",     TO, "RocksClientRemote(306);");


// Mute ALL players
//
bind(keyboard0, make, alt,         "[",     TO, "RocksClientRemote(307);");


// Unmute ALL player
//
bind(keyboard0, make, alt,         "]",     TO, "RocksClientRemote(308);");




// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// ------- Don't edit anything below here.  Do so at your own risk. ---------
// ------- Don't edit anything below here.  Do so at your own risk. ---------
// ------- Don't edit anything below here.  Do so at your own risk. ---------
// ------- Don't edit anything below here.  Do so at your own risk. ---------
// ------- Don't edit anything below here.  Do so at your own risk. ---------
// ------- Don't edit anything below here.  Do so at your own risk. ---------
// --------------------------------------------------------------------------
// --------------------------------------------------------------------------
// Create an object that I can use to attach values to
//
$self			= newObject("", SimSet);
$self.playerID		= 0;
$self.selectPlayer	= 0;
$self.selectVehicle	= 0;
$self.selectIndex	= 0;



// --------------------------------------------------------------------------
// Displays the Player info
//
function RocksClientPlayerInfo(%player)
{
	%info = "\t" @ getName(%player);

	if (%player == $self.selectPlayer)
		%info = %info @ " (Selected)";

	say($self.playerID, 0, %info);
}


// --------------------------------------------------------------------------
// Displays the Player info for all players.
//
function RocksClientShowAll()
{
	%count = playerManager::getPlayerCount();

	for (%i = 0; %i < %count; %i++) {
		%player = playerManager::getPlayerNum(%i);

		if (%player)
			RocksClientPlayerInfo(%player);
	}
}


// --------------------------------------------------------------------------
// Performs forward or backward Player selection thru the player-list.
//
function RocksClientSelect(%forward)
{
	%count = playerManager::getPlayerCount();


	// Normally I would do this with mod-arithmetic, but since
	// everything is in floating point, it's a bad idea.
	//
	if (%forward) {
		$self.selectIndex++;
		if ($self.selectIndex >= %count)
			$self.selectIndex = 0;
	}
	else {
		$self.selectIndex--;
		if ($self.selectIndex < 0)
			$self.selectIndex = %count-1;
	}

	$self.selectPlayer  = playerManager::getPlayerNum($self.selectIndex);
	$self.selectVehicle = 0;

	if ($self.selectPlayer)
		RocksClientPlayerInfo($self.selectPlayer);
}


// --------------------------------------------------------------------------
// Finds out which player you have targeted
//
function RocksClientTargetPlayer()
{
	// Fulgore showed me this little trick.  It returns the vehicleID
	// of whoever I have targeted.  The other 'correct' function-call
	// only works on the server I guess.
	//
	%vehicle = getTargetID(getNextObject("Squad", 0));

	if (!%vehicle)
		return(0);

	return(playerManager::vehicleIdToPlayerNum(%vehicle));
}


// --------------------------------------------------------------------------
// Finds out which vehicle another player has targeted.
//
function RocksClientTargetVehicle()
{
	return(getTargetID(getNextObject("Squad", 0)));
}


// --------------------------------------------------------------------------
// Mutes/Unmutes a Player's chats
//
function RocksClientMute(%player, %mute)
{
	if (%mute) {
		ignorePlayer(%player, true);
		%info = "\tMuted:\t " @ getName(%player);
	}
	else {
		ignorePlayer(%player, false);
		%info = "\tUNMuted:\t " @ getName(%player);
	}

	say($self.playerID, 0, %info);
}


// --------------------------------------------------------------------------
// Mutes/Unmutes ALL Player's chats
//
function RocksClientMuteAll(%player, %mute)
{
	if (%mute)
		%mute = true;
	else %mute = false;

	%count = playerManager::getPlayerCount();

	for (%i = 0; %i < %count; %i++) {
		%player = playerManager::getPlayerNum(%i);

		if ($self.playerID != %player)
			ignorePlayer(%player, %mute);
	}

	if (%mute)
		%info = "\tMuted:\t All Players";
	else %info = "\tUNMuted:\t All Players";

	say($self.playerID, 0, %info);
}


// --------------------------------------------------------------------------
// This is the client's entry point from the key-bindings
//
function RocksClientRemote(%code)
{

	// Cool... I can get my own playerID in anybody's server
	// with this function.
	//
	$self.playerID	= getConnectedClient();

	%selfID		= $self.playerID;
	%selectPlayer	= $self.selectPlayer;



	// -------------------------------------------------------------
	// -------------------------------------------------------------
	// -------------------------------------------------------------
	// These codes don't need a selected player to operate
	//
	if (%code == 300) {			// Select player forward
		RocksClientSelect(1);
		return;
	}

	if (%code == 301) {			// Select player backward
		RocksClientSelect(0);
		return;
	}

	if (%code == 302) {			// Select the targeted vehicle
		$self.selectPlayer = RocksClientTargetPlayer();
		%selectPlayer	= $self.selectPlayer;

		if (%selectPlayer)
			RocksClientPlayerInfo(%selectPlayer);
		else {
			$self.selectVehicle = RocksClientTargetVehicle();

			if ($self.selectVehicle) {
				say (%selfID, 0, "\t" @
					getHUDName($self.selectVehicle) @
					" (Selected)");
			}
			else say (%selfID, 0, "\tNo Targeted Vehicle");
		}

		return;
	}

	if (%code == 303) {			// Show all players
		RocksClientShowAll();
		return;
	}

	if (%code == 307) {			// Mute All players
		RocksClientMuteAll(%selectPlayer, 1);
		return;
	}

	if (%code == 308) {			// UNMute All players
		RocksClientMuteAll(%selectPlayer, 0);
		return;
	}


	// -------------------------------------------------------------
	// -------------------------------------------------------------
	// -------------------------------------------------------------
	// These codes need a selected player
	//
	if (%selectPlayer) {

		if (%code == 304) {		// Show selected player
			RocksClientPlayerInfo(%selectPlayer);
			return;
		}

		if (%code == 305) {		// Mute selected player
			if (%selectPlayer != selfID)
				RocksClientMute(%selectPlayer, 1);
			else say(%selfID, 0, "\tCan't mute yourself");
			return;
		}

		if (%code == 306) {		// Unmute selected player
			if (%selectPlayer != selfID)
				RocksClientMute(%selectPlayer, 0);
			else say(%selfID, 0, "\tCan't unmute yourself");
			return;
		}


		// Since it was none of the above, it might be one of the
		// vehicle codes below, so get the player's vehicle.
		//
		$self.selectVehicle =
			playerManager::playerNumTovehicleId(%selectPlayer);


		if (!$self.selectVehicle) {
			say (%selfID, 0, "\t" @
				getName(%selectPlayer) @ " has no Vehicle.");

			return;
		}
	}
	else {
		$self.selectPlayer = 0;
		%selectPlayer = 0;
	}



	// selectVehicle gets set either at the bottom of the previous
	// if-statement, which is the typical case, or because a clone/AI
	// was possibly selected... clones/AI have no players.  But we
	// also have to make sure someone didn't destroy it.
	//
	if ($self.selectVehicle) {

		if (%selectPlayer)
			%saystr = RocksClientPlayerInfo(%selectPlayer);
		else %saystr = "\t" @ getHUDName($self.selectVehicle);


		if (%code == 304) {		// Show selected clone/AI
			say (%selfID, 0, %saystr @ " (Selected)");
			return;
		}
	}
	else $self.selectVehicle = 0;


	say (%selfID, 0, "\tNo Player/Vehicle Selected or Unknown Code");
}

